;
; NCMACRO.ASM
;
; Copyright (c) 1994, Anton I. Steblev
;
; Moscow, Russia, phone 323-0117
;
; E-Mail: ittimsk@sovam.com
;	  71664.2062@compuserve.com
;	  2:5020/239.0@fidonet.org
;
;----------------------------------------------------------------------------
;
; This program is being distributed as free software. You are allowed
; to make any changes and improvements in the code as long as they do not
; affect the copyright information. It is suggested that you would inform
; the author about the changes you have made.
;
;----------------------------------------------------------------------------

CLogoString	 EQU \
'NC Macro V1.1, (c) 1994, Anton I. Steblev, Moscow, Russia, (095) 323-0117'

	LOCALS	@@

Pointer STRUC			; pointer definition
	Offs	DW	0
	Segm	DW	0
Pointer ENDS

GetVect MACRO	Num, Addr	; Get Interrupt Vector routine
	mov	ah, 35h
	mov	al, Num
	int	21h

	IFNB	<Addr>
	mov	Addr.Offs, bx
	mov	Addr.Segm, es
	ENDIF
ENDM

SetVect MACRO	Num, Addr	; Set Interrupt Vector routine
	mov	ah, 25h
	mov	al, Num
	lea	dx, Addr
	int	21h
ENDM

ICall	MACRO	Addr		; INT simulation
	pushf
	call	cs: DWORD PTR Addr
ENDM

CommandTable	STRUC			; macro table entry structure
	ScanCode	DB	0
	KeyboardFlags	DB	0
	VCFlags 	DB	0
	MacroString	DB	0
CommandTable	ENDS

Delimeter	EQU	word PTR 0FFFFh

;----------------------------------------------------------------------------

FirstEntry = 0

Entry MACRO ScanCode, KbdFlags, VCFlags
	IFB <ScanCode>
	  %OUT *Error* -- Invalid Entry Macro Directive
	  .ERR1
	ENDIF
	IF FirstEntry ne 0
	  DW	Delimeter
	ELSE
	  FirstEntry = 1
	ENDIF
	DB ScanCode
	IFNB <KbdFlags>
	  DB NOT (  ( KbdFlags ) SHL 4 ) AND ( KbdFlags )
	ELSE
	  DB 0
	ENDIF
	IFNB <VCFlags>
	  DB (VCFlags)
	ELSE
	  DB vcDontCare
	ENDIF
ENDM

Key	MACRO Code
	IFB <Code>
	  %OUT *Error* -- Invalid Key Macro Directive
	  .ERR1
	ENDIF
	IRP X, <Code>
	  DB	Low( X ), High( X )
	ENDM
ENDM

String	MACRO S
	IFB <S>
	  %OUT *Error* -- Invalid String Macro Directive
	  .ERR1
	ENDIF
	irpc _C, <S>
	  DB '&_C&' , 0
	ENDM
ENDM

DiskDef EQU BYTE PTR 0EEh

DiskSwitching = 0

Disk	MACRO KbdFlags, KeyCode
	DiskSwitching = 1
	IFB <KbdFlags>
	  %OUT *Error* -- Invalid Disk Macro Directive
	  .ERR1
	ENDIF
	Entry DiskDef, <KbdFlags>
	Key <KeyCode>
ENDM

;----------------------------------------------------------------------------

PutCode MACRO Code
	mov	cx, WORD PTR Code
	mov	ah, 05h
	int	16h
ENDM

SetStack MACRO
	push	ax bx cx dx di si ds es
ENDM

RestoreStack MACRO
	pop	es ds si di dx cx bx ax
ENDM

;============================================================================

Code	SEGMENT

	ASSUME	cs : Code, ds : Code

	ORG	100h

Start:	jmp	Initialize

OldInt9   Pointer <>
OldInt21  Pointer <>

Commands:
	INCLUDE KEYS.INC
	INCLUDE COMMANDS.INC
	DW	Delimeter		; The end_of_table marker

	IF	DiskSwitching EQ 1

; Conversion table, used to translate scan codes to characters for disk
; switching.

ScanTable	DB	16, 17, 18, 19, 20, 21, 22, 23, 24, 25
		DB	30, 31, 32, 33, 34, 35, 36, 37, 38
		DB	44, 45, 46, 47, 48, 49, 50
TableSize = $ - ScanTable

AsciiTable	DB	'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P'
		DB	'A', 'S', 'D', 'F', 'G', 'H', 'J', 'K', 'L'
		DB	'Z', 'X', 'C', 'V', 'B', 'N', 'M'

	ENDIF

	IFDEF	VC

VC_Flags	DB	0

; The following code of Int21 routine is used solely to overcome DOS's
; non-reenterability when calling to the VC TSR manager but VC is not
; loaded.

NewInt21 PROC FAR
	cmp	ah, 2Bh
	jne	@@10

	cmp	cx, 'VC'
	jne	@@10
	cmp	dx, 'OM'
	jne	@@10

	mov	al, 0FFh
	iret

@@10:	jmp	DWORD PTR cs:OldInt21
NewInt21 ENDP

	ENDIF

IsNortonActive PROC NEAR		; Check on the NC/VC activity

	IFDEF	VC

	mov	cs:VC_Flags, 0		; clear VC flags

	mov	cx, 'VC'                ; call VC TSR manager
	mov	dx, 'OM'
	mov	ax, 2B00h
	int	21h
	cmp	al, 0FFh		; failed ?
	je	@@10			; if E yes

	mov	ah, 62h 		; call DOS, get current PSP
	int	21h
	mov	ax, es
	cmp	ax, bx
	jne	@@10			; if NE no

	ENDIF

	mov	dx, 0B800h
	mov	ds, dx
	mov	dx, 40h
	mov	es, dx
	mov	di, es:[4Eh]		; page offset
	add	di, ( 80 * 10 + 39 ) * 2
	cmp	BYTE PTR [di], ''
	jne	@@5
	cmp	BYTE PTR [di+2], ''
	jne	@@5

	IFDEF	VC
	or	cs:VC_Flags, vcPanelsON
	jmp	@@6
@@5:	or	cs:VC_Flags, vcPanelsOFF
	ELSE
@@5:
	ENDIF
@@6:	clc
	ret
@@10:	stc
	ret
IsNortonActive ENDP

TestFlags PROC NEAR

	IFDEF	VC

	mov	al, es:[di].VCFlags
	test	al, cs:VC_Flags
	jz	@@10

	ENDIF

	push	dx
	mov	al, es:[di].KeyboardFlags
	mov	ah, al
	shr	al, 4
	not	al
	and	dh, al
	mov	al, ah
	and	al, 0Fh
	cmp	dh, al
	pop	dx
	jne	@@10

	mov	al, ah
	shr	al, 4
	jz	@@5
	test	dh, al
	jz	@@10

@@5:	clc
	ret
@@10:	stc
	ret
TestFlags ENDP

;----------------------------------------------------------------------------
NewInt9 PROC FAR
;----------------------------------------------------------------------------

	SetStack

	in	al, 60h 		; get scan code

	test	al, 80h 		; is a key released?
	jnz	@@250			; if NZ yes, go out

	push	ax
	call	IsNortonActive
	pop	ax
	jc	@@250

	mov	bx, cs			; set the data segment
	mov	es, bx			;

	lea	di, Commands		; set the command table offset

	xor	bx, bx			; load the BIOS segment
	mov	ds, bx			;
	mov	dh, ds:[417h]		; load the flags
	and	dh, 0Fh 		; clear high byte

	mov	dl, al			; copy scan code
	cld				; set forth direction

@@50:	cmp	es:[di], Delimeter	; is end of table reached?
	je	@@250			; if E yes, go out

	cmp	dl, es:[di].ScanCode	; do the scan codes match?
	je	@@210			; if E yes, process

	cmp	es:[di].ScanCode, DiskDef ; is this a disk switch entry?
	jne	@@220			; if NE no, next macro

	call	TestFlags		; do the flags match?
	jc	@@220			; C if yes

	IF	DiskSwitching EQ 1

@@100:	push	di			; save offset to current entry
	mov	al, dl			; load scan code
	lea	di, ScanTable		; load the ScanTable offset
	mov	cx, TableSize		; set counter
  repne scasb				; search
	jne	@@150			; if NE not found, next macro

	dec	di
	mov	bh, dl			; preserve the scan code
	sub	di, OFFSET ScanTable	; get ASCII symbol of scan code
	add	di, OFFSET AsciiTable	;
	mov	bl, es:[di]		; load the symbol
	pop	di			; restore entry offset
	jmp	@@300			; go to put codes

@@150:	pop	di			; restore entry offset
	jmp	SHORT @@220		; go for next macro

	ENDIF

@@210:	xor	bx, bx			; no extra codes to be put
	call	TestFlags		; compare the flags
	jnc	@@300			; NC if they match

@@220:	mov	al, Low( Delimeter )	; shift to the next macro
	mov	cx, 0FFFFh		;   just put some junk in cx
  repne scasb				;   search for the macro delimeter
	jne	@@250			;   if NE we've missed
	cmp	es:[di], High( Delimeter ) ; compare second byte
	jne	@@250			; if NE out
	inc	di			; skip delimeter
	jmp	SHORT @@50		; process macro

@@250:	RestoreStack
	jmp	DWORD PTR cs:OldInt9	; else no macro has been found,
					; FAR jump to the old routine

@@300:					; we got here when a macro is found

	lea	si, es:[di].MacroString ; set macro expansion offset
@@310:	cmp	es:[si], Delimeter	; is delimeter reached?
	je	@@500			; if E yes, go out
	PutCode es:[si] 		; output
	inc	si			; shift
	inc	si			;
	jmp	SHORT @@310		; loop

@@500:	test	bx, bx			; do we have extra code?
	jz	@@510			; if Z no
	PutCode bx

@@510:	mov	ax, ds:[41Ch]		; save keyboard buffer tail pointer
	ICall	OldInt9 		; execute old handler
	mov	ds:[41Ch], ax		; restore the pointer

	RestoreStack
	iret				; and leave

NewInt9 ENDP

EndOfResident LABEL BYTE

; ===========================================================================

Message MACRO	Mes
	lea	dx, Mes
	mov	ah, 09h
	int	21h
ENDM

LogoString	DB	0Ah, 0Dh, CLogoString, 0Ah, 0Dh, '$'
ErrorString	DB	0Ah, 0Dh, 'Can not stay resident.', 0Ah, 0Dh, '$'

; ===========================================================================
Initialize:
;============================================================================

	Message LogoString

	GetVect 9h, OldInt9		; set interrupt vectors
	SetVect 9h, NewInt9

	IFDEF	VC

	GetVect 21h, OldInt21
	SetVect 21h, NewInt21

	ENDIF

	mov	es, ds:[2Ch]		; kill the program environment
	mov	ah, 49h
	int	21h

	lea	dx, EndOfResident	; keep the resident part in memory
	int	27h			;

	Message ErrorString

@@Quit: int	20h			; Quit program if an error occurs

Code	ENDS

	END	Start			; That's all folks!
